#include <iostream>

using namespace std;

int main()
{
    int w,h,r,q;
    cin >> w >> h >> r >> q;
    int m[1000][1000];
    for(int i=1;i<=h;i++)
    {
        for(int j=1;j<=w;j++) m[i][j]=1;
    }
    for(int i=0;i<q;i++)
    {
        int x;
        cin >> x;
        if(x==1)
        {
            int a,b;
            cin >> a >> b;
            if(b==1) m[a][b]=0;
            else m[a][b-1]=m[a][b]=0;
            
        }
        else
        {
            int c,s=0;
            cin >> c;
            for(int i=1;i<=w;i++) s+=m[c][i];
            cout << s << endl;
        }
    }
    
    return 0;
}